/*Scrivere un programma per la gestione di matrici di double, che contenga i seguenti metodi:

Una funzione create, che riceve due interi (dimensione di righe e colonne), crea una matrice delle dimensioni indicate, e restituisce il suo puntatore.
Un metodo erase, che azzera tutti gli elementi della matrice.
Un metodo read per la lettura di una matrice da tastiera.
Un metodo print per la stampa della matrice su output.
Un metodo media_tutti_postivi che resituisce (in maniera opportuna usando i puntatori) la media di tutta la matrice e 
una booleana che risulta vera se la matrice è composta da elementi tutti positivi. */

#include <stdio.h>
#include <stdlib.h>

typedef enum {false,true} bool;


double** create(int,int);
void erase(double**,int,int);
void read (double**,int,int);
void print (double**,int,int);
bool mediaTutti_Positivi(double**,int,int, double *);

int main(){
double **mat;

int r,c, i;

double media;
bool tutti_pos;


printf("Inserire il numero di righe della matrice:\n");
scanf("%d",&r);
printf("Inserire il numero di colonne della matrice:\n");
scanf("%d",&c);
mat=create(r,c);
erase(mat,r,c);
printf("Inserire gli elementi della matrice:\n");
read(mat,r,c);
printf("Matrice letta:\n");
print(mat,r,c);
printf("\n");
// calcolo la media e se la matirce ha elementi tutti positivi
tutti_pos=mediaTutti_Positivi(mat,r,c,&media);
printf ("Media=%lf\n",media);
if (tutti_pos)
	printf("La matrice e' composta da elementi tutti positivi\n");
else
	printf("La matrice non e' composta da elementi tutti positivi\n");

printf ("Libero la memoria... \n");
for (i=0;i<r;i++)
	{
		free(mat[i]);
	}
free(mat);
return 0;
}

double** create(int r,int c){
double **m;
int i;
m=(double**)malloc(r*sizeof(double*));
if (m==NULL)
{
        printf ("MEMORIA NON DISPONIBILE! \n");
        exit (-1);
}
else
{
        for (i=0;i<r;i++)
        {
            m[i]=(double*) malloc (c*sizeof(double));
            if (m[i]==NULL)
            {
                printf ("MEMORIA NON DISPONIBILE! \n");
                free(m);
                exit(-1);
            }
        }
}
return m;
}

void erase(double**m,int r,int c){
int i,j;
for(i=0;i<r;i++){
	for(j=0;j<c;j++){
		m[i][j]=0;
		}
}
}

void read(double**m,int r,int c){
int i,j;
for(i=0;i<r;i++){
	for(j=0;j<c;j++){
		printf("m[%d,%d]> ",i,j);
		scanf("%lf",&m[i][j]);
	}
}
}

void print(double**m,int r,int c){
int i,j;
for(i=0;i<r;i++){
	for(j=0;j<c;j++){
		printf("%.3lf\t",m[i][j]);
	}
	printf("\n");
}
}

bool mediaTutti_Positivi(double**m,int r,int c, double *media){
int i,j;
*media=0;
bool positivi=true;
for(i=0;i<r;i++){
	for(j=0;j<c;j++){
		*media+=m[i][j];
		if (m[i][j]<=0)
			positivi=false;
	}
}
*media/=(r*c);
return positivi;
}
